#define API_TOKEN "{PUT-YOUR-TOKEN-HERE}"
#define API_KEY   "{PUT-YOUR-KEY-HERE}"

#include <iostream>

#include "windows.h"
#include "stdafx.h"

#include "json/json.h"
#include "evpeverywhere.h"

int _tmain(int argc, _TCHAR* argv[])
{
	std::string   identifier = "MSFT";
	std::string   date       = "20190601";
	float         shares     = 75.5f;
	std::string   report     = "dod";
	DWORD         error;
	std::string   result;
	Evpeverywhere evpeverywhere(API_TOKEN, API_KEY);

	error = evpeverywhere.GetEstatevalReport(identifier, shares, date, report, result);
	if (error != 0)
	{
		std::cout << "ERROR: Could not make connection to pricing service (" << error << ")!" << std::endl;
	}
	else
	{
	    Json::Reader parser;
	    Json::Value  json;
		float        value = 0;
		float        accrual = 0;

		parser.parse(result, json);

		if (json["output"]["status"] == "error")
		{
			std::cout << "ERROR: " << json["output"]["error-text"].asString() << std::endl;
		}
		else
		{
			if (!json["output"]["report"]["total"]["@value"].empty())
			{
				value = stof(json["output"]["report"]["total"]["@value"].asString());
			}
			if (!json["output"]["report"]["total"]["@accrual"].empty())
			{
				accrual = stof(json["output"]["report"]["total"]["@accrual"].asString());
			}

			std::cout << "Name: " << json["output"]["report"]["lot"][0]["inventory"][0]["@name"].asString() << " (" << shares << " shares/par on " << date << ")" << std::endl;
			std::cout << "    Value: " << value << std::endl;
			std::cout << "  Accrual: " << accrual << std::endl;
		}
	}
}
