#include "windows.h"
#include "winhttp.h"

#include "evpeverywhere.h"

#pragma comment(lib, "winhttp.lib")

Evpeverywhere::Evpeverywhere(std::string strToken, std::string strKey)
{
	m_strToken = strToken;
	m_strKey = strKey;
}

DWORD Evpeverywhere::GetEstatevalReport(std::string strIdentifier, float fShares, std::string strDate, std::string strReport, std::string& strOutput)
{
    HINTERNET         hSession;
    HINTERNET         hConnect;
    HINTERNET         hRequest;
	DWORD             dwResult = 0;
    std::vector<BYTE> vecbBody;

    vecbBody.resize(0);

    hSession = WinHttpOpen(
		L"EVP Everywhere Win32 Library/1.0",
		WINHTTP_ACCESS_TYPE_DEFAULT_PROXY,
		WINHTTP_NO_PROXY_NAME,
		WINHTTP_NO_PROXY_BYPASS,
		0);
    if (!hSession)
	{
		dwResult = 1;
	}

	if (!dwResult)
	{
		hConnect = WinHttpConnect(
			hSession,
			L"api.evpsys.com",
			INTERNET_DEFAULT_HTTPS_PORT,
			0);
		if (!hConnect)
		{
			dwResult = 2;
		}
	}

	if (!dwResult)
	{
		wchar_t temp[32+1];

		swprintf(temp, sizeof(temp), L"%g", fShares);
		std::wstring requestUrl =
			L"/estateval/report?"
			L"version=1.0&"
			L"output=json&"
			L"identifier=" + std::wstring(strIdentifier.begin(), strIdentifier.end()) +
			L"&shares=" + temp +
			L"&date=" + std::wstring(strDate.begin(), strDate.end()) +
			L"&report=" + std::wstring(strReport.begin(), strReport.end());
		hRequest = WinHttpOpenRequest(
			hConnect,
			L"GET",
			requestUrl.c_str(),
			NULL,
			WINHTTP_NO_REFERER,
			WINHTTP_DEFAULT_ACCEPT_TYPES,
			WINHTTP_FLAG_SECURE);
		if (!hRequest)
		{
			dwResult = 3;
		}
	}

	if (!dwResult)
	{

		if (!WinHttpSetCredentials(
			hRequest,
			WINHTTP_AUTH_TARGET_SERVER,
			WINHTTP_AUTH_SCHEME_BASIC,
			std::wstring(m_strToken.begin(), m_strToken.end()).c_str(),
			std::wstring(m_strKey.begin(), m_strKey.end()).c_str(),
			NULL))
		{
			dwResult = 4;
		}
	}

	if (!dwResult)
	{
		if (!WinHttpSendRequest(
			hRequest,
			WINHTTP_NO_ADDITIONAL_HEADERS,
			0,
			WINHTTP_NO_REQUEST_DATA,
			0,
			0,
			0))
		{
			dwResult = 5;
		}
	}

	if (!dwResult)
	{
		if (!WinHttpReceiveResponse(
			hRequest,
			NULL))
		{
			dwResult = 6;
		}
	}

	if (!dwResult)
	{
		DWORD dwHttpStatus = 0;
		DWORD dwHttpStatusSize = sizeof(dwHttpStatus);

		if (!WinHttpQueryHeaders(
			hRequest,
		    WINHTTP_QUERY_STATUS_CODE | WINHTTP_QUERY_FLAG_NUMBER, 
		    WINHTTP_HEADER_NAME_BY_INDEX, 
			&dwHttpStatus,
			&dwHttpStatusSize,
			WINHTTP_NO_HEADER_INDEX))
		{
			dwResult = 7;
		}
		if (!dwResult && dwHttpStatus != 200)
		{
			dwResult = 8;
		}
	}

	if (!dwResult)
	{
		DWORD dwSize;

		do
		{
			dwSize = 0;
			if (!WinHttpQueryDataAvailable(
				hRequest,
				&dwSize))
			{
				dwResult = 9;
				break;
			}
			if (dwSize == 0)
			{
				break;
			}

			do
			{
				DWORD dwDownloaded;
				DWORD dwOffset = vecbBody.size();

				vecbBody.resize(dwOffset + dwSize);

				if (!WinHttpReadData(
					hRequest,
					&vecbBody[dwOffset],
					dwSize,
					&dwDownloaded))
				{
					dwResult = 10;
					break;
				}
				if (dwDownloaded == 0)
				{
					break;
				}

				vecbBody.resize(dwOffset + dwDownloaded);
				dwSize -= dwDownloaded;
			} while (dwSize > 0);
		} while (true);
	}

    if (hRequest)
	{
		WinHttpCloseHandle(hRequest);
	}
    if (hConnect)
	{
		WinHttpCloseHandle(hConnect);
	}
    if (hSession)
	{
		WinHttpCloseHandle(hSession);
	}

	strOutput = std::string(vecbBody.begin(), vecbBody.end());

	return dwResult;
}
